Description

Now, ObjectSpace.memsize_of(obj) return without sizeof(RVALUE).
For example, ObjectSpace.memsize_of('foo') returns 0 because shorter string are embedded in RVALUE.

Proposal is returning the size including sizeof(RVALUE).
If we introduce variable RVALUE size (*1), then it will help.

*1: for example, T_FLOAT only use sizeof(double).
Only 2 words (or 1 word on 64bit enviornment) are needed.

Question is: it breaks compatibility, but anyone care about it?

Another option is to add optional parameter. memsize_of(obj, include_rvalue: true), etc.

Associated revisions

Revision 85b42fe17b67688143e26f72b47aad766744ac3a - 12/15/2014 08:54 AM - ko1 (Koichi Sasada)

* ext/objspace/objspace.c: ObjectSpace.memsize_of(obj) returns
with sizeof(RVALUE). [Bug #8984]

gc.c (obj_memsize_of): ditto.

NEWS: add a NEWS entry.

test/objspace/test_objspace.rb: catch up this fix.
test/ruby/test_file_exhaustive.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48846 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 85b42fe1 - 12/15/2014 08:54 AM - ko1 (Koichi Sasada)

¢ ext/objspace/objspace.c: ObjectSpace.memsize_of(obj) returns
with sizeof(RVALUE). [Bug #8984]

gc.c (obj_memsize_of): ditto.

NEWS: add a NEWS entry.

test/objspace/test_objspace.rb: catch up this fix.
test/ruby/test_file_exhaustive.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48846 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/09/2013 07:04 AM - sam.saffron (Sam Saffron)

Personally | have only ever seen mention of this in http://stackoverflow.com/questions/10068018/memory-size-of-a-hash-or-other-object

| googled pretty hard and all | saw was wonderful pictures of tenderlove and a slightly less accurate description here:
http://www.slideshare.net/tenderlove/hidden-gems-of-ruby-19 http://imgur.com/yeFYtiM

| think we should break compatibility here and properly document, cause people just have no idea about this now

#2 - 01/30/2014 06:17 AM - hsbt (Hiroshi SHIBATA)
- Target version changed from 2.1.0 to 2.2.0

#3 - 12/15/2014 08:54 AM - ko1 (Koichi Sasada)

- Status changed from Assigned to Closed

06/14/2025 12



http://stackoverflow.com/questions/10068018/memory-size-of-a-hash-or-other-object
http://imgur.com/yeFYtiM

- % Done changed from 0 to 100

Applied in changeset r48846.

e ext/objspace/objspace.c: ObjectSpace.memsize_of(obj) returns
with sizeof(RVALUE). [Bug #8984]

gc.c (obj_memsize_of): ditto.

NEWS: add a NEWS entry.

test/objspace/test_objspace.rb: catch up this fix.
test/ruby/test_file_exhaustive.rb: ditto.

#4 - 01/20/2015 02:44 AM - usa (Usaku NAKAMURA)
- Backport changed from 1.9.3: UNKNOWN, 2.0.0: UNKNOWN to 2.0.0: WONTFIX, 2.1: UNKNOWN
